/**
 * Module:  xmos_ethernet
 * Version: 1V0
 * Build:   f1883729a5d482be1a08ab78fe03cf855d12b541
 * File:    src/mac/server/mii_queue.h
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 *
 * In the case where this code is a modification of existing code
 * under a separate license, the separate license terms are shown
 * below. The modifications to the code are still covered by the 
 * copyright notice above.
 *
 **/                                   
#ifndef __mii_queue_h__
#define __mii_queue_h__

#include <xccompat.h>

#define MAX_NUM_QUEUES 10
#define MAX_ENTRIES 64

typedef struct mii_queue_t {
  int lock;
  int rdIndex;
  int wrIndex;
  int fifo[MAX_ENTRIES];
} mii_queue_t;


void init_queue(REFERENCE_PARAM(mii_queue_t, q), int n);
int get_queue_entry(REFERENCE_PARAM(mii_queue_t, q));
void add_queue_entry(REFERENCE_PARAM(mii_queue_t, q), int i);
void init_queues();
void set_transmit_count(int buf_num, int count);
int get_and_dec_transmit_count(int buf_num);
int get_queue_entry_no_lock(REFERENCE_PARAM(mii_queue_t,q));
#endif //__mii_queue_h__
