/**
 * Module:  xmos_ethernet
 * Version: 1V0
 * Build:   f1883729a5d482be1a08ab78fe03cf855d12b541
 * File:    src/mac/server/mii_wrappers.c
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 *
 * In the case where this code is a modification of existing code
 * under a separate license, the separate license terms are shown
 * below. The modifications to the code are still covered by the 
 * copyright notice above.
 *
 **/                                   
#include <xccompat.h>
#define streaming 
#include "mii.h"
#include "mii_queue.h"
#include "mii_filter.h"
#include <print.h>


mii_queue_t free_queue, filter_queue, internal_queue, ts_queue;
mii_queue_t tx_queue[2];

mii_packet_t mii_packet_buf[NUM_MII_BUF+1]={1};

void init_mii_mem() {
  int i;  
  init_queues();
  init_queue(&free_queue, NUM_MII_BUF);
  init_queue(&filter_queue, 0);
  init_queue(&internal_queue, 0);
  init_queue(&ts_queue, 0);
  for(i=0;i<2;i++)
    init_queue(&tx_queue[i], 0);
  return;
}

void mii_rx_pins_wr(port p1,
                    port p2,
                    int i,
                    streaming chanend c)
{
  mii_rx_pins(&free_queue, mii_packet_buf, p1, p2, i, c);
}


void mii_tx_pins_wr(port p,
                    int i)
{
  mii_tx_pins(mii_packet_buf, &tx_queue[i], &free_queue, &ts_queue, p, i);
}


void two_port_filter_wr(const int mac[2], streaming chanend c, streaming chanend d)
{
  two_port_filter(mii_packet_buf,
                  mac, 
                  &free_queue, 
                  &internal_queue,
                  &tx_queue[0], 
                  &tx_queue[1],
                  c,
                  d);
}


void one_port_filter_wr(const int mac[2], streaming chanend c)
{
  one_port_filter(mii_packet_buf,
                  mac, 
                  &free_queue, 
                  &internal_queue,
                  c);
}

